Module | ActionView::Helpers::JavaScriptHelper
In: | lib/action_view/helpers/javascript_helper.rb

Provides functionality for working with JavaScript in your views.

## Ajax, controls and visual effects

- For information on using Ajax, see ActionView::Helpers::PrototypeHelper.
- For information on using controls and visual effects, see ActionView::Helpers::ScriptaculousHelper.

## Including the JavaScript libraries into your pages

Rails includes the Prototype JavaScript framework and the Scriptaculous JavaScript controls and visual effects library. If you wish to use these libraries and their helpers (ActionView::Helpers::PrototypeHelper and ActionView::Helpers::ScriptaculousHelper), you must do one of the following:

- Use `<%= javascript_include_tag :defaults %>` in the HEAD section of your page (recommended): This function will return references to the JavaScript files created by the `rails` command in your `public/javascripts` directory. Using it is recommended as the browser can then cache the libraries instead of fetching all the functions anew on every request.
- Use `<%= javascript_include_tag ‘prototype’ %>`: As above, but will only include the Prototype core library, which means you are able to use all basic AJAX functionality. For the Scriptaculous-based JavaScript helpers, like visual effects, autocompletion, drag and drop and so on, you should use the method described above.
- Use `<%= define_javascript_functions %>`: this will copy all the JavaScript support functions within a single script block. Not recommended.

For documentation on `javascript_include_tag` see ActionView::Helpers::AssetTagHelper.

### Methods

array_or_string_for_javascript button_to_function define_javascript_functions escape_javascript javascript_tag link_to_function options_for_javascript

### Constants

JAVASCRIPT_PATH | = | File.join(File.dirname(__FILE__), 'javascripts')

### Public Instance methods

button_to_function(name, function, html_options = {})

Returns a link that‘ll trigger a JavaScript `function` using the onclick handler.

Examples:

      button_to_function "Greeting", "alert('Hello world!')"
      button_to_function "Delete", "if confirm('Really?'){ do_delete(); }")

define_javascript_functions()

Includes the Action Pack JavaScript libraries inside a single <script> tag. The function first includes prototype.js and then its core extensions, (determined by filenames starting with "prototype"). Afterwards, any additional scripts will be included in undefined order.

Note: The recommended approach is to copy the contents of lib/action_view/helpers/javascripts/ into your application‘s public/javascripts/ directory, and use `javascript_include_tag` to create remote <script> links.

escape_javascript(javascript)

Escape carrier returns and single and double quotes for JavaScript segments.

javascript_tag(content)

Returns a JavaScript tag with the `content` inside. Example:

      javascript_tag "alert('All is good')" # => <script type="text/javascript">alert('All is good')</script>

link_to_function(name, function, html_options = {})

Returns a link that‘ll trigger a JavaScript `function` using the onclick handler and return false after the fact.

Examples:

      link_to_function "Greeting", "alert('Hello world!')"
      link_to_function(image_tag("delete"), "if confirm('Really?'){ do_delete(); }")

### Protected Instance methods

array_or_string_for_javascript(option)
options_for_javascript(options)

[Validate]